.\"	$NetBSD: viaide.4,v 1.9 2007/08/31 01:39:46 xtraeme Exp $
.\"
.\" Copyright (c) 2003 Manuel Bouyer.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
.\" IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
.\" OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
.\" IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
.\" INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
.\" NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
.\" DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
.\" THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
.\" INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
.\" THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.Dd August 31, 2007
.Dt VIAIDE 4
.Os
.Sh NAME
.Nm viaide
.Nd AMD, NVIDIA and VIA IDE disk controllers driver
.Sh SYNOPSIS
.Cd "viaide* at pci? dev ? function ? flags 0x0000"
.Cd "options PCIIDE_AMD756_ENABLEDMA"
.Sh DESCRIPTION
The
.Nm
driver supports the following IDE controllers
and provides the interface with the hardware for the
.Ic ata
driver:
.Bl -dash -compact -offset indent
.It
Advanced Micro Devices AMD-756, 766, 768 and CS5536 IDE Controllers
.It
NVIDIA nForce, nForce2, nForce2 400, nForce3, nForce3 250,
nForce4, MCP04, MCP55, MCP61, MCP65, MCP67 IDE and SATA Controllers.
.It
VIA Technologies VT82C586, VT82C586A, VT82C596A, VT82C686A, VT8233A,
VT8235, VT8237/VT8237R IDE Controllers, VT6421 Serial RAID Controller and
CX700 IDE Controller.
.El
.Pp
The 0x0002 flag forces the
.Nm
driver to disable DMA on chipsets for which DMA would normally be
enabled.
This can be used as a debugging aid, or to work around
problems where the IDE controller is wired up to the system incorrectly.
.Sh SEE ALSO
.Xr ata 4 ,
.Xr atapi 4 ,
.Xr intro 4 ,
.Xr pci 4 ,
.Xr pciide 4 ,
.Xr wd 4 ,
.Xr wdc 4
.Sh NOTES
Drives on the VT6421 Serial RAID Controller can only be accessed
after they have been configured into RAID or JBOD sets via its
BIOS.
It is also inaptly named as it has both SATA and PATA interfaces.
.Sh BUGS
The AMD756 chip revision D2 has a bug affecting DMA (but not Ultra-DMA)
modes.
The workaround documented by AMD is to not use DMA on any drive which
does not support Ultra-DMA modes.
This does not appear to be necessary on all drives, the
PCIIDE_AMD756_ENABLEDMA option can be used to force multiword DMA
on the buggy revisions.
Multiword DMA can eventually be disabled on a
per-drive basis with config flags, see
.Xr wd 4 .
The bug, if triggered, will cause a total system hang.
.Pp
The timings used for the PIO and DMA modes for controllers listed above
are for a PCI bus running at 30 or 33 MHz.
This driver may not work properly on overclocked systems.
